com.google.cloud.dataflow.sdk.options

## Interface DefaultValueFactory<T>

Type Parameters:
  `T` - The type of object this factory produces.

All Known Implementing Classes:
  BlockingDataflowPipelineOptions.StandardOutputFactory, DataflowPipelineDebugOptions.DataflowClientFactory, DataflowPipelineDebugOptions.PathValidatorFactory, DataflowPipelineDebugOptions.StagerFactory, DataflowPipelineOptions.JobNameFactory, DataflowPipelineWorkerPoolOptions.WorkerHarnessContainerImageFactory, GcpOptions.CredentialDirFactory, GcpOptions.DefaultProjectFactory, GcpOptions.GcpUserCredentialsFactory, GcsOptions.ExecutorServiceFactory

    public interface DefaultValueFactory<T>

An interface used with the `Default.InstanceFactory` annotation to specify the class that will be an instance factory to produce default values for a given getter on `PipelineOptions`. When a property on a `PipelineOptions` is fetched, and is currently unset, the default value factory will be instantiated and invoked.

Care must be taken to not produce an infinite loop when accessing other fields on the `PipelineOptions` object.

### Method Summary

All Methods Instance Methods Abstract Methods
`T` `create(PipelineOptions options)` Creates a default value for a getter marked with `Default.InstanceFactory`.

### Method Detail

#### create

    T create(PipelineOptions options)

Creates a default value for a getter marked with `Default.InstanceFactory`.

Parameters:
  `options` - The current pipeline options.
Returns:
  The default value to be used for the annotated getter.